ColumnFamilyStoreMBean (apache-cassandra API)
Date: 2014-10-21

org.apache.cassandra.db

## Interface ColumnFamilyStoreMBean

- All Known Implementing Classes:
    ColumnFamilyStore

      public interface ColumnFamilyStoreMBean

  The MBean interface for ColumnFamilyStore

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `estimateKeys()`
    `void` | `forceMajorCompaction()` force a major compaction of this column family
    `long` | `getBloomFilterDiskSpaceUsed()` Deprecated.
    `long` | `getBloomFilterFalsePositives()` Deprecated.
    `double` | `getBloomFilterFalseRatio()` Deprecated.
    `java.util.List<java.lang.String>` | `getBuiltIndexes()` Returns a list of the names of the built column indexes for current store
    `java.lang.String` | `getColumnFamilyName()`
    `java.lang.String` | `getCompactionStrategyClass()` Gets the compaction strategy class name
    `java.util.Map<java.lang.String,java.lang.String>` | `getCompressionParameters()` Get the compression parameters
    `double` | `getCompressionRatio()` Deprecated.
    `double` | `getDroppableTombstoneRatio()` Get the ratio of droppable tombstones to real columns (and non-droppable tombstones)
    `long[]` | `getEstimatedColumnCountHistogram()` Deprecated.
    `long[]` | `getEstimatedRowSizeHistogram()` Deprecated.
    `long[]` | `getLifetimeReadLatencyHistogramMicros()` Deprecated.
    `long[]` | `getLifetimeWriteLatencyHistogramMicros()` Deprecated.
    `double` | `getLiveCellsPerSlice()` Deprecated.
    `long` | `getLiveDiskSpaceUsed()` Deprecated.
    `int` | `getLiveSSTableCount()` Deprecated.
    `int` | `getMaximumCompactionThreshold()` Gets the maximum number of sstables in queue before compaction kicks off
    `long` | `getMaxRowSize()` Deprecated.
    `long` | `getMeanRowSize()` Deprecated.
    `long` | `getMemtableColumnsCount()` Deprecated.
    `long` | `getMemtableDataSize()` Deprecated.
    `int` | `getMemtableSwitchCount()` Deprecated.
    `int` | `getMinimumCompactionThreshold()` Gets the minimum number of sstables in queue before compaction kicks off
    `long` | `getMinRowSize()` Deprecated.
    `int` | `getPendingTasks()` Deprecated.
    `long` | `getReadCount()` Deprecated.
    `long` | `getRecentBloomFilterFalsePositives()` Deprecated.
    `double` | `getRecentBloomFilterFalseRatio()` Deprecated.
    `long[]` | `getRecentReadLatencyHistogramMicros()` Deprecated.
    `double` | `getRecentReadLatencyMicros()` Deprecated.
    `long[]` | `getRecentSSTablesPerReadHistogram()` Deprecated.
    `long[]` | `getRecentWriteLatencyHistogramMicros()` Deprecated.
    `double` | `getRecentWriteLatencyMicros()` Deprecated.
    `int[]` | `getSSTableCountPerLevel()`
    `java.util.List<java.lang.String>` | `getSSTablesForKey(java.lang.String key)` Returns a list of filenames that contain the given key on this node
    `long[]` | `getSSTablesPerReadHistogram()` Deprecated.
    `double` | `getTombstonesPerSlice()` Deprecated.
    `long` | `getTotalDiskSpaceUsed()` Deprecated.
    `long` | `getTotalReadLatencyMicros()` Deprecated.
    `long` | `getTotalWriteLatencyMicros()` Deprecated.
    `int` | `getUnleveledSSTables()`
    `long` | `getWriteCount()` Deprecated.
    `boolean` | `isAutoCompactionDisabled()`
    `void` | `loadNewSSTables()` Scan through Keyspace/ColumnFamily's data directory determine which SSTables should be loaded and load them
    `void` | `setCompactionStrategyClass(java.lang.String className)` Sets the compaction strategy by class name
    `void` | `setCompactionThresholds(int minThreshold, int maxThreshold)` Sets the maximum and maximum number of SSTables in queue before compaction kicks off
    `void` | `setCompressionParameters(java.util.Map<java.lang.String,java.lang.String> opts)` Set the compression parameters
    `void` | `setCrcCheckChance(double crcCheckChance)` Set new crc check chance
    `void` | `setMaximumCompactionThreshold(int threshold)` Sets the maximum number of sstables in queue before compaction kicks off
    `void` | `setMinimumCompactionThreshold(int threshold)` Sets the minimum number of sstables in queue before compaction kicks off
    `long` | `trueSnapshotsSize()`

- - ### Method Detail

    - #### getColumnFamilyName

          java.lang.String getColumnFamilyName()

      Returns:
        the name of the column family

    - #### getMemtableDataSize

          @Deprecated
          long getMemtableDataSize()

      Deprecated.
      Returns the total amount of data stored in the memtable, including column related overhead.
      Returns:
        The size in bytes.
      See Also:
        `ColumnFamilyMetrics.memtableOnHeapSize`

    - #### getMemtableColumnsCount

          @Deprecated
          long getMemtableColumnsCount()

      Deprecated.
      Returns the total number of columns present in the memtable.
      Returns:
        The number of columns.
      See Also:
        `ColumnFamilyMetrics.memtableColumnsCount`

    - #### getMemtableSwitchCount

          @Deprecated
          int getMemtableSwitchCount()

      Deprecated.
      Returns the number of times that a flush has resulted in the memtable being switched out.
      Returns:
        the number of memtable switches
      See Also:
        `ColumnFamilyMetrics.memtableSwitchCount`

    - #### getRecentSSTablesPerReadHistogram

          @Deprecated
          long[] getRecentSSTablesPerReadHistogram()

      Deprecated.
      Returns:
        a histogram of the number of sstable data files accessed per read: reading this property resets it
      See Also:
        `ColumnFamilyMetrics.recentSSTablesPerRead`

    - #### getSSTablesPerReadHistogram

          @Deprecated
          long[] getSSTablesPerReadHistogram()

      Deprecated.
      Returns:
        a histogram of the number of sstable data files accessed per read
      See Also:
        `ColumnFamilyMetrics.sstablesPerReadHistogram`

    - #### getReadCount

          @Deprecated
          long getReadCount()

      Deprecated.
      Returns:
        the number of read operations on this column family
      See Also:
        `ColumnFamilyMetrics.readLatency`

    - #### getTotalReadLatencyMicros

          @Deprecated
          long getTotalReadLatencyMicros()

      Deprecated.
      Returns:
        total read latency (divide by getReadCount() for average)
      See Also:
        `ColumnFamilyMetrics.readLatency`

    - #### getLifetimeReadLatencyHistogramMicros

          @Deprecated
          long[] getLifetimeReadLatencyHistogramMicros()

      Deprecated.
      Returns:
        an array representing the latency histogram
      See Also:
        `ColumnFamilyMetrics.readLatency`

    - #### getRecentReadLatencyHistogramMicros

          @Deprecated
          long[] getRecentReadLatencyHistogramMicros()

      Deprecated.
      Returns:
        an array representing the latency histogram
      See Also:
        `ColumnFamilyMetrics.readLatency`

    - #### getRecentReadLatencyMicros

          @Deprecated
          double getRecentReadLatencyMicros()

      Deprecated.
      Returns:
        average latency per read operation since the last call
      See Also:
        `ColumnFamilyMetrics.readLatency`

    - #### getWriteCount

          @Deprecated
          long getWriteCount()

      Deprecated.
      Returns:
        the number of write operations on this column family
      See Also:
        `ColumnFamilyMetrics.writeLatency`

    - #### getTotalWriteLatencyMicros

          @Deprecated
          long getTotalWriteLatencyMicros()

      Deprecated.
      Returns:
        total write latency (divide by getReadCount() for average)
      See Also:
        `ColumnFamilyMetrics.writeLatency`

    - #### getLifetimeWriteLatencyHistogramMicros

          @Deprecated
          long[] getLifetimeWriteLatencyHistogramMicros()

      Deprecated.
      Returns:
        an array representing the latency histogram
      See Also:
        `ColumnFamilyMetrics.writeLatency`

    - #### getRecentWriteLatencyHistogramMicros

          @Deprecated
          long[] getRecentWriteLatencyHistogramMicros()

      Deprecated.
      Returns:
        an array representing the latency histogram
      See Also:
        `ColumnFamilyMetrics.writeLatency`

    - #### getRecentWriteLatencyMicros

          @Deprecated
          double getRecentWriteLatencyMicros()

      Deprecated.
      Returns:
        average latency per write operation since the last call
      See Also:
        `ColumnFamilyMetrics.writeLatency`

    - #### getPendingTasks

          @Deprecated
          int getPendingTasks()

      Deprecated.
      Returns:
        the estimated number of tasks pending for this column family
      See Also:
        `ColumnFamilyMetrics.pendingFlushes`

    - #### getLiveSSTableCount

          @Deprecated
          int getLiveSSTableCount()

      Deprecated.
      Returns:
        the number of SSTables on disk for this CF
      See Also:
        `ColumnFamilyMetrics.liveSSTableCount`

    - #### getLiveDiskSpaceUsed

          @Deprecated
          long getLiveDiskSpaceUsed()

      Deprecated.
      Returns:
        disk space used by SSTables belonging to this CF
      See Also:
        `ColumnFamilyMetrics.liveDiskSpaceUsed`

    - #### getTotalDiskSpaceUsed

          @Deprecated
          long getTotalDiskSpaceUsed()

      Deprecated.
      Returns:
        total disk space used by SSTables belonging to this CF, including obsolete ones waiting to be GC'd
      See Also:
        `ColumnFamilyMetrics.totalDiskSpaceUsed`

    - #### forceMajorCompaction

          void forceMajorCompaction()
                                    throws java.util.concurrent.ExecutionException,
                                           java.lang.InterruptedException

      force a major compaction of this column family
      Throws:
        `java.util.concurrent.ExecutionException`
        `java.lang.InterruptedException`

    - #### getMinRowSize

          @Deprecated
          long getMinRowSize()

      Deprecated.
      Returns:
        the size of the smallest compacted row
      See Also:
        `ColumnFamilyMetrics.minRowSize`

    - #### getMaxRowSize

          @Deprecated
          long getMaxRowSize()

      Deprecated.
      Returns:
        the size of the largest compacted row
      See Also:
        `ColumnFamilyMetrics.maxRowSize`

    - #### getMeanRowSize

          @Deprecated
          long getMeanRowSize()

      Deprecated.
      Returns:
        the average row size across all the sstables
      See Also:
        `ColumnFamilyMetrics.meanRowSize`

    - #### getBloomFilterFalsePositives

          @Deprecated
          long getBloomFilterFalsePositives()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.bloomFilterFalsePositives`

    - #### getRecentBloomFilterFalsePositives

          @Deprecated
          long getRecentBloomFilterFalsePositives()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.recentBloomFilterFalsePositives`

    - #### getBloomFilterFalseRatio

          @Deprecated
          double getBloomFilterFalseRatio()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.bloomFilterFalseRatio`

    - #### getRecentBloomFilterFalseRatio

          @Deprecated
          double getRecentBloomFilterFalseRatio()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.recentBloomFilterFalseRatio`

    - #### getBloomFilterDiskSpaceUsed

          @Deprecated
          long getBloomFilterDiskSpaceUsed()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.bloomFilterDiskSpaceUsed`

    - #### getMinimumCompactionThreshold

          int getMinimumCompactionThreshold()

      Gets the minimum number of sstables in queue before compaction kicks off

    - #### setMinimumCompactionThreshold

          void setMinimumCompactionThreshold(int threshold)

      Sets the minimum number of sstables in queue before compaction kicks off

    - #### getMaximumCompactionThreshold

          int getMaximumCompactionThreshold()

      Gets the maximum number of sstables in queue before compaction kicks off

    - #### setCompactionThresholds

          void setCompactionThresholds(int minThreshold,
                                     int maxThreshold)

      Sets the maximum and maximum number of SSTables in queue before compaction kicks off

    - #### setMaximumCompactionThreshold

          void setMaximumCompactionThreshold(int threshold)

      Sets the maximum number of sstables in queue before compaction kicks off

    - #### setCompactionStrategyClass

          void setCompactionStrategyClass(java.lang.String className)

      Sets the compaction strategy by class name
      Parameters:
        `className` - the name of the compaction strategy class

    - #### getCompactionStrategyClass

          java.lang.String getCompactionStrategyClass()

      Gets the compaction strategy class name

    - #### getCompressionParameters

          java.util.Map<java.lang.String,java.lang.String> getCompressionParameters()

      Get the compression parameters

    - #### setCompressionParameters

          void setCompressionParameters(java.util.Map<java.lang.String,java.lang.String> opts)

      Set the compression parameters
      Parameters:
        `opts` - map of string names to values

    - #### setCrcCheckChance

          void setCrcCheckChance(double crcCheckChance)

      Set new crc check chance

    - #### isAutoCompactionDisabled

          boolean isAutoCompactionDisabled()

    - #### getTombstonesPerSlice

          @Deprecated
          double getTombstonesPerSlice()

      Deprecated.
      Number of tombstoned cells retreived during the last slicequery

    - #### getLiveCellsPerSlice

          @Deprecated
          double getLiveCellsPerSlice()

      Deprecated.
      Number of live cells retreived during the last slicequery

    - #### estimateKeys

          long estimateKeys()

    - #### getEstimatedRowSizeHistogram

          @Deprecated
          long[] getEstimatedRowSizeHistogram()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.estimatedRowSizeHistogram`

    - #### getEstimatedColumnCountHistogram

          @Deprecated
          long[] getEstimatedColumnCountHistogram()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.estimatedColumnCountHistogram`

    - #### getCompressionRatio

          @Deprecated
          double getCompressionRatio()

      Deprecated.
      See Also:
        `ColumnFamilyMetrics.compressionRatio`

    - #### getBuiltIndexes

          java.util.List<java.lang.String> getBuiltIndexes()

      Returns a list of the names of the built column indexes for current store
      Returns:
        list of the index names

    - #### getSSTablesForKey

          java.util.List<java.lang.String> getSSTablesForKey(java.lang.String key)

      Returns a list of filenames that contain the given key on this node
      Parameters:
        `key` -
      Returns:
        list of filenames containing the key

    - #### loadNewSSTables

          void loadNewSSTables()

      Scan through Keyspace/ColumnFamily's data directory determine which SSTables should be loaded and load them

    - #### getUnleveledSSTables

          int getUnleveledSSTables()

      Returns:
        the number of SSTables in L0. Always return 0 if Leveled compaction is not enabled.

    - #### getSSTableCountPerLevel

          int[] getSSTableCountPerLevel()

      Returns:
        sstable count for each level. null unless leveled compaction is used. array index corresponds to level(int[0] is for level 0, ...).

    - #### getDroppableTombstoneRatio

          double getDroppableTombstoneRatio()

      Get the ratio of droppable tombstones to real columns (and non-droppable tombstones)
      Returns:
        ratio

    - #### trueSnapshotsSize

          long trueSnapshotsSize()

      Returns:
        the size of SSTables in "snapshots" subdirectory which aren't live anymore

Copyright © 2014 The Apache Software Foundation